###################################################################
package BU::PSA::Objects::DNSRec;
###################################################################

require 5.004;
require Exporter;
use Carp;
use BU::PSA::Const;
use BU::PSA::Logger;
use BU::PSA::DB;

use BU::PSA::Objects::Object;

@ISA = qw(BU::PSA::Objects::Object);


sub init($ $ $ $; $ $)
{
	my $self = shift @_;
	my ($dom_id, $host, $type, $val, $opt, $time_stamp) = @_;

	my $fields = $self->{dbFields};

	defined($dom_id) and $fields->{dom_id} = $dom_id or croak "Argument 'dom_id' is undefined.";
	defined($host) and $fields->{host} = $host or croak "Argument 'host' is undefined.";
	defined($type) and $fields->{type} = $type or croak "Argument 'type' is undefined.";
	defined($val) and $fields->{val} = $val or croak "Argument 'val' is undefined.";
	
	defined($opt) and $fields->{opt} = $opt;
	defined($time_stamp) and $fields->{time_stamp} = $time_stamp;

	$self->{dbFieldsNames} = {
								'dom_id' => 1, 'type' => 1,	'host' => 1, 'val' => 1,
								'opt' => 0, 'time_stamp' => 0
							};

	$self->{dbTable} = 'dns_recs';
	$self->{Changeable} = 1;

	$self->SUPER::init(@_);

	print_stdout ("==>DNS recs: ", $fields->{host}, " ", $fields->{type}, " ", $fields->{val}, "\n") if ($debug > 0);

	return $self;
}


sub dbGetIdCondition()
{
	my ($self) = @_;

	my $fields = $self->{dbFields};

	my $condition = 'dom_id=' . $fields->{dom_id}
			. ' and type="' . $fields->{type} . '"'
			. ' and host=' . dbQuote($fields->{host})
			. ' and val=' . dbQuote($fields->{val});

	if (exists($fields->{opt}) && $fields->{opt}) {
		$condition .= ' and opt="' . $fields->{opt} .'"';
	}

	return $condition;
}


sub dbExistsCondition()
{
	my ($self) = @_;

	return $self->dbGetIdCondition();
}


return 1;

