###################################################################
package BU::PSA::Objects::DomainLimits;
###################################################################

require 5.004;
require Exporter;
use Carp;
use BU::PSA::Const;
use BU::PSA::DB;

use BU::PSA::Objects::Limits;

@ISA = qw(BU::PSA::Objects::Limits);

sub init($ $)
{
	my $self = shift @_;
	my ($domainId, $limitsId) = @_;

	$self->SUPER::init($limitsId);

	$$self{domainId} = $domainId;

	return $self;
}


sub getUsedResourceFromDB_($)
{
	my ($self, $limit) = @_;
	$self->resetError();

	my $query_str = '';

	if ($limit eq 'max_box') {
		$query_str = 'select COUNT(*) from mail where postbox="true" and dom_id=\'' . $$self{domainId} . '\'';
	} elsif ($limit eq 'max_redir') {
		$query_str = 'select COUNT(*) from mail where redirect="true" and dom_id=\'' . $$self{domainId} . '\'';
	} elsif ($limit eq 'max_mg') {
		$query_str = 'select COUNT(*) from mail where mail_group="true" and dom_id=\'' . $$self{domainId} . '\'';
	} elsif ($limit eq 'max_resp') {
		$query_str = 'select COUNT(*) from mail_resp r, mail m where r.mn_id=m.id and r.resp_on="true" and m.dom_id=\'' . $$self{domainId} . '\'';
	} elsif ($limit eq 'max_wu') {
		$query_str = 'select COUNT(*) from web_users where dom_id=\'' . $$self{domainId} . '\'';
	} elsif ($limit eq 'max_db') {
		$query_str = 'select COUNT(*) from data_bases where dom_id=\'' . $$self{domainId} . '\'';
	} elsif ($limit eq 'max_webapps') {
		$query_str = 'select COUNT(*) from WebApps wa, DomainServices ds where wa.domain_service_id=ds.id and ds.type="tomcat" and ds.dom_id=\'' . $$self{domainId} . '\'';
	} elsif ($limit eq 'max_maillists') {
		$query_str = 'select COUNT(*) from MailLists where dom_id=\'' . $$self{domainId} . '\'';
	} else {
		$self->setError("Unknown limit name '$limit'");
		return undef;
	}

	$query = dbDoQuery($query_str);
	unless ($query) {
		$self->setError("Unable to define used resource value for domain limit '$limit'");
		return undef;
	}

	my ($ret) = $query->fetchrow_array();
	return $ret;
}


sub getUsedResource($)
{
	my ($self, $limit) = @_;

	$self->resetError();

	my $ret = undef;
	if ($limit =~ /^(disk_space|max_traffic|mbox_quota)$/) {
		$ret = 0;
	} elsif ($limit =~ /^(max_box|max_redir|max_mg|max_resp|max_wu|max_db|max_webapps|max_maillists)$/) {
		$ret = $self->getUsedResourceFromDB_($limit);
	} else {
		$self->setError("Unknown limit name '$limit'");
		$ret = undef;
	}

	return $ret;
}

return 1;

