###################################################################
package BU::PSA::Objects::WebUser;
###################################################################

require 5.004;
require Exporter;
use Carp;
use BU::PSA::Const;
use BU::PSA::CommonFunc;
use BU::PSA::Objects::SysUser;

use BU::PSA::Objects::Object;
@ISA = qw(BU::PSA::Objects::Object);


sub init($ $ $; $)
{
	my $self = shift @_;
	my ($domainId, $login, $passwd, $passwd_type, $home, $shell, $quota) = @_;

	my $fields = $self->{dbFields};

	$self->{sysUser} = new BU::PSA::Objects::SysUser($login, $passwd, $passwd_type, $home, $shell, $quota);

	defined($domainId) and $fields->{dom_id} = $domainId;

	defined($uid) and $self->{uid} = $uid;

	$self->{dbFieldsNames} = {
								'dom_id' => 0, 'sys_user_id' => 1,
								'ssi' => 0, 'asp' => 0, 'python' => 0,
								'perl' => 0, 'cgi' => 0, 'php' => 0
							};

	$$self{action_log_map} = {
			'ssi' => COMP_SSI_SUPPORT,
			'asp' => COMP_ASP_SUPPORT,
			'python' => COMP_PYTHON_SUPPORT,
			'perl' => COMP_PERL_SUPPORT,
			'cgi' => COMP_CGI_SUPPORT,
			'php' => COMP_PHP_SUPPORT
	};

	$self->{dbTable} = 'web_users';
	$self->{Changeable} = '';

	$self->SUPER::init(@_);

	return $self;
}


sub getChangedComponents
{
	my $self = shift @_;

	my $diff1 = $self->SUPER::getChangedComponents(@_);
	my $diff2 = $self->{sysUser}->getChangedComponents();

	my %diff = (%$diff1, %$diff2);

	return \%diff;
}


sub dbGetIdCondition()
{
	my ($self) = @_;
	my $sysUser = $self->{sysUser};

	unless ($sysUser->Exists()) {
		return '1=0';
	}

	return 'sys_user_id=' . $sysUser->getDBId();
}


sub dbExistsCondition()
{
	my ($self) = @_;

	return $self->dbGetIdCondition();
}


sub doCheckExists
{
	my ($self) = @_;

	return $self->{sysUser}->doCheckExists();
}

sub Store
{
	my ($self) = @_;

	$self->resetError();

	my $sysUser = $self->{sysUser};

	$sysUser->Store();

	if ($sysUser->error()) {
		$self->setError('Unable to create sys user: ' . $sysUser->getErrorMsg());
		return '';
	}

	$self->setField('sys_user_id', $sysUser->getDBId());

	return $self->SUPER::Store();
}

sub doCreate()
{
	my ($self) = @_;

	$self->resetError();

	return 1;
}

return 1;

