###################################################################
package BU::PSA::Restore::ActionLog;
###################################################################

require 5.004;
require Exporter;
use Carp;

use BU::PSA::Const;
use BU::Logger;

use BU::PSA::CommonFunc;
use BU::PSA::ActionLog;
use BU::PSA::DB;

@ISA = qw(BU::PSA::ActionLog);

@EXPORT = qw(restoreActionLog logAction);

sub restoreActionLog($$$)
{
	my ($node, $object_id, $object_type) = @_; ### $object_type is unsed now

	return unless ($node && $object_id);

	foreach my $sn ($node->xql('./action_log/*')) { ### get action node
		my $action_id = getActionId(u2a($sn->getAttribute('name')));
		dbDoQuery('INSERT INTO log_actions(date, ip_address, user, action_id, object_id) VALUES('
					. dbQuote(u2a($sn->getAttribute('date'))) . ','
					. dbQuote(u2a($sn->getAttribute('ip_address'))) . ','
					. dbQuote(u2a($sn->getAttribute('user'))) . ','
					. "'$action_id', '$object_id'"
					. ')'
				);

		my $logged_action_id = dbGetInsertId();

		foreach my $sn2 ($sn->xql('./*')) { ### get component node
			dbDoQuery('INSERT INTO log_components(action_id, component, old_value, new_value) VALUES('
				. "$logged_action_id, "
				. dbQuote(u2a($sn2->getAttribute('name'))) . ','
				. dbQuote(u2a($sn2->getAttribute('old_value'))) . ','
				. dbQuote(u2a($sn2->getAttribute('new_value')))
				. ')'
			);
		}
	}
}

return 1;
