###################################################################
package BU::Semaphore;
###################################################################

require 5.004;
require Exporter;
use Carp;

use BU::Logger;
use IPC::SysV qw(IPC_PRIVATE S_IRWXU IPC_CREAT IPC_EXCL SEM_UNDO);
use IPC::Semaphore;

@ISA = qw(Exporter);
@EXPORT = qw(semInit semGetVal semSetVal semOP semRemove semGetKey SEM_UNDO, semID);

my $sem;
my $sem_key;
my $sem_number;


sub semInit
{
	my ($sem_number_, $sem_key_) = @_;

	unless ($sem_number_) {
		croak "Semaphores number must be specified.\n";
	}
	$sem_number = $sem_number_;

	if ($sem_key_) {
		$sem_key = $sem_key_;
	} else {
		$sem_key = IPC_PRIVATE;
	}

	$sem = new IPC::Semaphore($sem_key, $sem_number, S_IRWXU | IPC_CREAT);

	unless ($sem) {
		print_log("Unable to create semaphore.\n");
		croak "Unable to create semaphore.\n";
	}

#	$sem->op(0, 1, SEM_UNDO);

	return 1;
}


sub semGetVal
{
	my ($sem_num) = @_;

	unless ($sem_num) {
		$sem_num =0;
	}

	return $sem->getval($sem_num);
}


sub semSetVal($ $)
{
	my ($sem_num, $val) = @_;

	return $sem->setval($sem_num, $val);
}


sub semOP($ $ $)
{
	my ($sem_num, $inc_val, $flags) = @_;

	return $sem->op($sem_num, $inc_val, $flags);
}


sub semRemove()
{
	$sem->remove();
}


sub semGetKey()
{
	return $sem_key;
}


sub semID()
{
	return $sem->id();
}

return 1;

