package BU::XML::File2xml;

require 5.000;
require Exporter;

use BU::Logger;

use MIME::Base64 qw(encode_base64 decode_base64);
use XML::DOM;
use File::Basename;


@ISA = qw(Exporter);
@EXPORT = qw(insertFile);

sub insertFile {
	my ($doc, $name, $file, $flag) = @_;
	my $str;

	my $node = $doc->createElement($name);
	$node->setAttribute('file',basename($file));
	if( -r $file and open(FF, $file) ) {
		local($/) = undef;
		if( $flag =~ m/bin.*|base64/i ) {
			$str="\n".encode_base64(<FF>) and
			$node->setAttribute('Encoding','base64');
		} else {
			$str=<FF>;
		}
		close FF || warn_log "Unable to close file %s . The cause: %!.\n", "$file\n";
		if("$str" ne "") {
			$node->appendChild( $doc->createTextNode($str) );
			return $node
		}
	}
	warn_log "Unable to read file: %s . The cause: %!. Suggested: Run as 'root'.\n","$file\n";
	$node->setAttribute('empty',1);
	return $node
}	

1;
__END__

=head1 NAME

Mandatory section; should be a comma-separated list of programs or functions documented by this podpage, such as: 

foo, bar - programs to do something

PSA:: - The PSA modules for ... .

=head1 SYNOPSIS

A short usage summary for programs and functions, which may someday be deemed mandatory. 

=head1 DESCRIPTION

Long drawn out discussion of the program. It's a good idea to break this up into subsections using the =head2 directives, like 

=head2 A Sample Subection

=head2 Yet Another Sample Subection

=head1 OPTIONS

Some people make this separate from the description. 

=head1 RETURN VALUE

What the program or function returns if successful. 

=head1 ERRORS

Exceptions, return codes, exit stati, and errno settings. 

=head1 EXAMPLES

Give some example uses of the program. 

=head1 ENVIRONMENT

Envariables this program might care about. 

=head1 FILES

All files used by the program. You should probably use the F<> for these. 

=head1 SEE ALSO

Other man pages to check out, like man(1), man(7), makewhatis(8), or catman(8). 

=head1 NOTES

Miscellaneous commentary. 

=head1 CAVEATS

Things to take special care with; sometimes called WARNINGS. 

=cut DIAGNOSTICS

All possible messages the program can print out--and what they mean. 

=head1 BUGS

